/*
Auto-generated by: https://github.com/pmndrs/gltfjsx
*/

import * as THREE from "three";
import { useEffect, useRef } from "react";
import { useGLTF, useAnimations } from "@react-three/drei";
import { type GLTF } from "three-stdlib";

type GLTFResult = GLTF & {
  nodes: {
    Cover: THREE.Mesh;
    PCB: THREE.Mesh;
    Cube: THREE.Mesh;
    Microcontroller: THREE.Mesh;
    Micro_USB: THREE.Mesh;
    Microcontroller002: THREE.Mesh;
    Microcontroller003: THREE.Mesh;
    Microcontrollercover: THREE.Mesh;
    Screw3: THREE.Mesh;
    Screw4: THREE.Mesh;
    Screw1: THREE.Mesh;
    Screw2: THREE.Mesh;
    Single_Cap: THREE.Mesh;
    Single_Cap001: THREE.Mesh;
    Single_Cap002: THREE.Mesh;
    Single_Cap003: THREE.Mesh;
    Single_Cap004: THREE.Mesh;
    Single_Cap005: THREE.Mesh;
    Single_Cap006: THREE.Mesh;
    Single_Cap007: THREE.Mesh;
    Single_Cap008: THREE.Mesh;
    Single_Cap009: THREE.Mesh;
    Single_Cap010: THREE.Mesh;
    Single_Cap011: THREE.Mesh;
    Single_Cap012: THREE.Mesh;
    Single_Cap013: THREE.Mesh;
    Single_Cap014: THREE.Mesh;
    Single_Cap015: THREE.Mesh;
    Single_Cap016: THREE.Mesh;
    Single_Cap017: THREE.Mesh;
    Single_Cap018: THREE.Mesh;
    Single_Cap019: THREE.Mesh;
    Single_Cap020: THREE.Mesh;
    Cover001: THREE.Mesh;
    PCB001: THREE.Mesh;
    Cube001: THREE.Mesh;
    Microcontroller004: THREE.Mesh;
    Micro_USB001: THREE.Mesh;
    Microcontroller005: THREE.Mesh;
    Microcontroller006: THREE.Mesh;
    Microcontrollercover001: THREE.Mesh;
    Screw3001: THREE.Mesh;
    Screw4001: THREE.Mesh;
    Screw1001: THREE.Mesh;
    Screw2001: THREE.Mesh;
    Single_Cap021: THREE.Mesh;
    Single_Cap022: THREE.Mesh;
    Single_Cap023: THREE.Mesh;
    Single_Cap024: THREE.Mesh;
    Single_Cap025: THREE.Mesh;
    Single_Cap026: THREE.Mesh;
    Single_Cap027: THREE.Mesh;
    Single_Cap028: THREE.Mesh;
    Single_Cap029: THREE.Mesh;
    Single_Cap030: THREE.Mesh;
    Single_Cap031: THREE.Mesh;
    Single_Cap032: THREE.Mesh;
    Single_Cap033: THREE.Mesh;
    Single_Cap034: THREE.Mesh;
    Single_Cap035: THREE.Mesh;
    Single_Cap036: THREE.Mesh;
    Single_Cap037: THREE.Mesh;
    Single_Cap038: THREE.Mesh;
    Single_Cap039: THREE.Mesh;
    Single_Cap040: THREE.Mesh;
    Single_Cap041: THREE.Mesh;
  };
  materials: {
    keycap: THREE.MeshPhysicalMaterial;
    Metal: THREE.MeshStandardMaterial;
  };
};

type GLTFActions = THREE.AnimationClip;

export function Model(props: JSX.IntrinsicElements["group"]) {
  const group = useRef<THREE.Group>();
  const { nodes, materials, animations } = useGLTF(
    "/keeb_but_rounder.glb"
  ) as GLTFResult;
  const { actions } = useAnimations<GLTFActions>(animations, group);

  useEffect(() => {
    actions.CoverAction!.play();
    actions["Cover.001Action"]!.play();
  }, []);
  return (
    //@ts-ignore
    <group ref={group} {...props} dispose={null}>
      <group name="Scene">
        <mesh
          name="Cover"
          castShadow
          receiveShadow
          geometry={nodes.Cover.geometry}
          material={materials.keycap}
          position={[0.277, 0.809, -1.087]}
          rotation={[-0.474, -0.617, -1.135]}
          scale={[0.681, 0.91, 0.884]}
        >
          <mesh
            name="PCB"
            castShadow
            receiveShadow
            geometry={nodes.PCB.geometry}
            material={materials.keycap}
            position={[-0.009, 0.003, 0.002]}
            scale={[0.966, 0.965, 0.973]}
          >
            <mesh
              name="Cube"
              castShadow
              receiveShadow
              geometry={nodes.Cube.geometry}
              material={materials.keycap}
              position={[-0.815, 0.034, 0.231]}
              scale={[2.112, 0.937, 1.162]}
            />
            <mesh
              name="Microcontroller"
              castShadow
              receiveShadow
              geometry={nodes.Microcontroller.geometry}
              material={materials.keycap}
              position={[-0.683, 0.045, -0.119]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.018, -0.157]}
            >
              <mesh
                name="Micro_USB"
                castShadow
                receiveShadow
                geometry={nodes.Micro_USB.geometry}
                material={materials.Metal}
                position={[0.134, 0.791, -1.152]}
                scale={0.987}
              />
              <mesh
                name="Microcontroller002"
                castShadow
                receiveShadow
                geometry={nodes.Microcontroller002.geometry}
                material={materials.keycap}
                position={[-0.665, 0.839, -0.033]}
              />
              <mesh
                name="Microcontroller003"
                castShadow
                receiveShadow
                geometry={nodes.Microcontroller003.geometry}
                material={materials.keycap}
                position={[0.885, 0.839, -0.033]}
              />
            </mesh>
            <mesh
              name="Microcontrollercover"
              castShadow
              receiveShadow
              geometry={nodes.Microcontrollercover.geometry}
              material={materials.keycap}
              position={[-0.679, 0.076, -0.009]}
              scale={[3.491, 1.14, 7.552]}
            >
              <mesh
                name="Screw3"
                castShadow
                receiveShadow
                geometry={nodes.Screw3.geometry}
                material={materials.Metal}
                position={[-0.028, 0.002, 0.038]}
                scale={[0.436, 1, 0.154]}
              />
              <mesh
                name="Screw4"
                castShadow
                receiveShadow
                geometry={nodes.Screw4.geometry}
                material={materials.Metal}
                position={[0.028, 0.002, 0.033]}
                scale={[0.436, 1, 0.154]}
              />
            </mesh>
            <mesh
              name="Screw1"
              castShadow
              receiveShadow
              geometry={nodes.Screw1.geometry}
              material={materials.Metal}
              position={[0.24, 0.019, 0.319]}
              scale={[1.52, 1.14, 1.162]}
            />
            <mesh
              name="Screw2"
              castShadow
              receiveShadow
              geometry={nodes.Screw2.geometry}
              material={materials.Metal}
              position={[-0.477, 0.019, 0.348]}
              scale={[1.52, 1.14, 1.162]}
            />
            <mesh
              name="Single_Cap"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap.geometry}
              material={materials.keycap}
              position={[-0.384, 0.077, -0.266]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap001"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap001.geometry}
              material={materials.keycap}
              position={[-0.384, 0.077, -0.046]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap002"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap002.geometry}
              material={materials.keycap}
              position={[-0.384, 0.077, 0.174]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap003"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap003.geometry}
              material={materials.keycap}
              position={[-0.102, 0.077, -0.307]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap004"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap004.geometry}
              material={materials.keycap}
              position={[-0.102, 0.077, -0.087]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap005"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap005.geometry}
              material={materials.keycap}
              position={[-0.102, 0.077, 0.133]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap006"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap006.geometry}
              material={materials.keycap}
              position={[0.18, 0.077, -0.32]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap007"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap007.geometry}
              material={materials.keycap}
              position={[0.18, 0.077, -0.101]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap008"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap008.geometry}
              material={materials.keycap}
              position={[0.18, 0.077, 0.119]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap009"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap009.geometry}
              material={materials.keycap}
              position={[0.462, 0.077, -0.279]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap010"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap010.geometry}
              material={materials.keycap}
              position={[0.462, 0.077, -0.06]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap011"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap011.geometry}
              material={materials.keycap}
              position={[0.462, 0.077, 0.16]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap012"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap012.geometry}
              material={materials.keycap}
              position={[0.744, 0.077, -0.215]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap013"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap013.geometry}
              material={materials.keycap}
              position={[0.744, 0.077, 0.004]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap014"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap014.geometry}
              material={materials.keycap}
              position={[0.744, 0.077, 0.224]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap015"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap015.geometry}
              material={materials.keycap}
              position={[1.025, 0.077, -0.215]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap016"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap016.geometry}
              material={materials.keycap}
              position={[1.025, 0.077, 0.004]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap017"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap017.geometry}
              material={materials.keycap}
              position={[1.025, 0.077, 0.224]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap018"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap018.geometry}
              material={materials.keycap}
              position={[0.013, 0.077, 0.376]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap019"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap019.geometry}
              material={materials.keycap}
              position={[-0.299, 0.077, 0.392]}
              rotation={[Math.PI, -0.137, Math.PI]}
              scale={[-0.136, -0.053, -0.084]}
            />
            <mesh
              name="Single_Cap020"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap020.geometry}
              material={materials.keycap}
              position={[-0.637, 0.077, 0.41]}
              rotation={[Math.PI, -0.298, Math.PI]}
              scale={[-0.134, -0.053, -0.086]}
            />
          </mesh>
        </mesh>
        <mesh
          name="Cover001"
          castShadow
          receiveShadow
          geometry={nodes.Cover001.geometry}
          material={materials.keycap}
          position={[-0.79, 1.276, -0.938]}
          rotation={[2.526, -1.219, -1.364]}
          scale={[-0.681, -0.91, -0.884]}
        >
          <mesh
            name="PCB001"
            castShadow
            receiveShadow
            geometry={nodes.PCB001.geometry}
            material={materials.keycap}
            position={[-0.009, 0.003, 0.002]}
            scale={[0.966, 0.965, 0.973]}
          >
            <mesh
              name="Cube001"
              castShadow
              receiveShadow
              geometry={nodes.Cube001.geometry}
              material={materials.keycap}
              position={[-0.815, 0.034, 0.231]}
              scale={[2.112, 0.937, 1.162]}
            />
            <mesh
              name="Microcontroller004"
              castShadow
              receiveShadow
              geometry={nodes.Microcontroller004.geometry}
              material={materials.keycap}
              position={[-0.683, 0.045, -0.119]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.018, -0.157]}
            >
              <mesh
                name="Micro_USB001"
                castShadow
                receiveShadow
                geometry={nodes.Micro_USB001.geometry}
                material={materials.Metal}
                position={[0.134, 0.791, -1.152]}
                scale={0.987}
              />
              <mesh
                name="Microcontroller005"
                castShadow
                receiveShadow
                geometry={nodes.Microcontroller005.geometry}
                material={materials.keycap}
                position={[-0.665, 0.839, -0.033]}
              />
              <mesh
                name="Microcontroller006"
                castShadow
                receiveShadow
                geometry={nodes.Microcontroller006.geometry}
                material={materials.keycap}
                position={[0.885, 0.839, -0.033]}
              />
            </mesh>
            <mesh
              name="Microcontrollercover001"
              castShadow
              receiveShadow
              geometry={nodes.Microcontrollercover001.geometry}
              material={materials.keycap}
              position={[-0.679, 0.076, -0.009]}
              scale={[3.491, 1.14, 7.552]}
            >
              <mesh
                name="Screw3001"
                castShadow
                receiveShadow
                geometry={nodes.Screw3001.geometry}
                material={materials.Metal}
                position={[-0.028, 0.002, 0.038]}
                scale={[0.436, 1, 0.154]}
              />
              <mesh
                name="Screw4001"
                castShadow
                receiveShadow
                geometry={nodes.Screw4001.geometry}
                material={materials.Metal}
                position={[0.028, 0.002, 0.033]}
                scale={[0.436, 1, 0.154]}
              />
            </mesh>
            <mesh
              name="Screw1001"
              castShadow
              receiveShadow
              geometry={nodes.Screw1001.geometry}
              material={materials.Metal}
              position={[0.24, 0.019, 0.319]}
              scale={[1.52, 1.14, 1.162]}
            />
            <mesh
              name="Screw2001"
              castShadow
              receiveShadow
              geometry={nodes.Screw2001.geometry}
              material={materials.Metal}
              position={[-0.477, 0.019, 0.348]}
              scale={[1.52, 1.14, 1.162]}
            />
            <mesh
              name="Single_Cap021"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap021.geometry}
              material={materials.keycap}
              position={[-0.384, 0.077, -0.266]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap022"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap022.geometry}
              material={materials.keycap}
              position={[-0.384, 0.077, -0.046]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap023"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap023.geometry}
              material={materials.keycap}
              position={[-0.384, 0.077, 0.174]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap024"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap024.geometry}
              material={materials.keycap}
              position={[-0.102, 0.077, -0.307]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap025"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap025.geometry}
              material={materials.keycap}
              position={[-0.102, 0.077, -0.087]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap026"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap026.geometry}
              material={materials.keycap}
              position={[-0.102, 0.077, 0.133]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap027"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap027.geometry}
              material={materials.keycap}
              position={[0.18, 0.077, -0.32]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap028"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap028.geometry}
              material={materials.keycap}
              position={[0.18, 0.077, -0.101]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap029"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap029.geometry}
              material={materials.keycap}
              position={[0.18, 0.077, 0.119]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap030"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap030.geometry}
              material={materials.keycap}
              position={[0.462, 0.077, -0.279]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap031"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap031.geometry}
              material={materials.keycap}
              position={[0.462, 0.077, -0.06]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap032"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap032.geometry}
              material={materials.keycap}
              position={[0.462, 0.077, 0.16]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap033"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap033.geometry}
              material={materials.keycap}
              position={[0.744, 0.077, -0.215]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap034"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap034.geometry}
              material={materials.keycap}
              position={[0.744, 0.077, 0.004]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap035"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap035.geometry}
              material={materials.keycap}
              position={[0.744, 0.077, 0.224]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap036"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap036.geometry}
              material={materials.keycap}
              position={[1.025, 0.077, -0.215]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap037"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap037.geometry}
              material={materials.keycap}
              position={[1.025, 0.077, 0.004]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap038"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap038.geometry}
              material={materials.keycap}
              position={[1.025, 0.077, 0.224]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap039"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap039.geometry}
              material={materials.keycap}
              position={[0.013, 0.077, 0.376]}
              rotation={[Math.PI, 0, Math.PI]}
              scale={[-0.137, -0.053, -0.083]}
            />
            <mesh
              name="Single_Cap040"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap040.geometry}
              material={materials.keycap}
              position={[-0.299, 0.077, 0.392]}
              rotation={[Math.PI, -0.137, Math.PI]}
              scale={[-0.136, -0.053, -0.084]}
            />
            <mesh
              name="Single_Cap041"
              castShadow
              receiveShadow
              geometry={nodes.Single_Cap041.geometry}
              material={materials.keycap}
              position={[-0.637, 0.077, 0.41]}
              rotation={[Math.PI, -0.298, Math.PI]}
              scale={[-0.134, -0.053, -0.086]}
            />
          </mesh>
        </mesh>
      </group>
    </group>
  );
}

useGLTF.preload("/keeb_but_rounder.glb");
